Package com.io7m.coffeepick.shipilev_net.internal

# Class ASFile.Builder

java.lang.Object
com.io7m.coffeepick.shipilev_net.internal.ASFile.Builder

Enclosing class:
  ASFile

    public static final class ASFile.Builder
    extends java.lang.Object

Builds instances of type `ASFile`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `ASFile` | `build()` | Builds a new `ASFile`.
  `ASFile.Builder` | `from​(ASFileType instance)` | Fill a builder with attribute values from the provided `ASFileType` instance.
  `ASFile.Builder` | `setDirectory​(java.lang.String directory)` | Initializes the value for the `directory` attribute.
  `ASFile.Builder` | `setName​(java.lang.String name)` | Initializes the value for the `name` attribute.
  `ASFile.Builder` | `setSize​(long size)` | Initializes the value for the `size` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final ASFile.Builder from​(ASFileType instance)
    Fill a builder with attribute values from the provided `ASFileType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setDirectory

    public final ASFile.Builder setDirectory​(java.lang.String directory)
    Initializes the value for the `directory` attribute.
    Parameters:
      `directory` - The value for directory
    Returns:
      `this` builder for use in a chained invocation

  - ### setName

    public final ASFile.Builder setName​(java.lang.String name)
    Initializes the value for the `name` attribute.
    Parameters:
      `name` - The value for name
    Returns:
      `this` builder for use in a chained invocation

  - ### setSize

    public final ASFile.Builder setSize​(long size)
    Initializes the value for the `size` attribute.
    Parameters:
      `size` - The value for size
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public ASFile build()
    Builds a new `ASFile`.
    Returns:
      An immutable instance of ASFile
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing